
public class ParseExampmle
{
    public static int parseString(String s)
    {
        if(s.length() == 1)
        {
            // Base case
            return s.charAt(0) - '0';
        }
        else
        {
            // Recursive case
            int count = 0;
            for(int i = 0; i < s.length(); ++i)
            {
                char c = s.charAt(i);
                if(c == '(') 
                    ++count;
                else if(c == ')')
                    --count;
                else if((c == '+' || c == '*') && count == 1)
                {
                    // Found the top level operator
                    String sLeft = s.substring(1 , i);
                    String sRight = s.substring(i+1, s.length()-1);
                    
                    int vLeft = parseString(sLeft);
                    int vRight = parseString(sRight);
                    
                    switch(c)
                    {
                        case '+':
                            return vLeft + vRight;
                        case '*':
                            return vLeft * vRight;
                    }
                }
            }
        }
        return -1;
    }
    
    
    public static void main(String[] args)
    {
        String s = "(5+(2*3))";
        s = "(((4+2)*(2*3))+((2+8)*(4+3)))";
        
        System.out.println(parseString(s));

    }

}
